/* motifCALC.c */
#include "motifCALC.h"

extern float gotoh_bp[13][496];

/* -------------------------------------------------------------------------- */

void gotoh_initBasePairTable() {

  int i, j;

  for(i=0; i<13; i++) 
    for(j=0; j<496; j++)
      gotoh_bp[i][j] = 0.;

  /*          A                        C                        G                        U         */
  /* type 1 -> cWW */
  gotoh_bp[1][65]  =  0.6; gotoh_bp[1][67]  =  0.9; gotoh_bp[1][71]  =  2.5; gotoh_bp[1][85]  = 24.9;  /* A */
  gotoh_bp[1][193] =  0.9; gotoh_bp[1][195] =  0.2; gotoh_bp[1][199] = 55.8; gotoh_bp[1][213] =  1.;   /* C */
  gotoh_bp[1][321] =  2.5; gotoh_bp[1][323] = 55.8; gotoh_bp[1][327] =  0.;  gotoh_bp[1][341] = 12.1;  /* G */
  gotoh_bp[1][449] = 24.9; gotoh_bp[1][451] =  1.;  gotoh_bp[1][455] = 12.1; gotoh_bp[1][469] = 1.6;   /* U */
  /* type 2 -> tWW */
  gotoh_bp[2][65]  = 32.6; gotoh_bp[2][67]  =  4.8; gotoh_bp[2][71]  =  0.;  gotoh_bp[2][85]  = 34.1;
  gotoh_bp[2][193] =  4.8; gotoh_bp[2][195] =  2.4; gotoh_bp[2][199] = 15.6; gotoh_bp[2][213] =  1.;
  gotoh_bp[2][321] =  0.;  gotoh_bp[2][323] = 15.6; gotoh_bp[2][327] =  5.9; gotoh_bp[2][341] =  0.9;
  gotoh_bp[2][449] = 34.1; gotoh_bp[2][451] =  1.;  gotoh_bp[2][455] =  0.9; gotoh_bp[2][469] =  1.9;
  /* type 3 -> cWH */
  gotoh_bp[3][65]  =  0.;  gotoh_bp[3][67]  =  0.;  gotoh_bp[3][71]  =  2.8; gotoh_bp[3][85]  =  0.2;
  gotoh_bp[3][193] =  0.;  gotoh_bp[3][195] =  3.4; gotoh_bp[3][199] =  0.3; gotoh_bp[3][213] =  0.;
  gotoh_bp[3][321] =  2.6; gotoh_bp[3][323] =  0.;  gotoh_bp[3][327] = 32.6; gotoh_bp[3][341] =  0.2;
  gotoh_bp[3][449] = 47.2; gotoh_bp[3][451] =  0.;  gotoh_bp[3][455] =  7.2; gotoh_bp[3][469] =  0.2;
  /* type 4 -> tWH */
  gotoh_bp[4][65]  = 12.4; gotoh_bp[4][67]  =  0.;  gotoh_bp[4][71]  =  0.3; gotoh_bp[4][85]  =  0.;
  gotoh_bp[4][193] = 13.5; gotoh_bp[4][195] =  0.2; gotoh_bp[4][199] =  2.1; gotoh_bp[4][213] =  0.;
  gotoh_bp[4][321] =  0.;  gotoh_bp[4][323] =  0.;  gotoh_bp[4][327] =  2.3; gotoh_bp[4][341] =  0.1;
  gotoh_bp[4][449] = 63.9; gotoh_bp[4][451] =  0.;  gotoh_bp[4][455] =  0.4; gotoh_bp[4][469] =  3.6;
  /* type 5 -> cWS */
  gotoh_bp[5][65]  = 14.5; gotoh_bp[5][67]  = 25.7; gotoh_bp[5][71]  =  2.6; gotoh_bp[5][85]  = 15.1;
  gotoh_bp[5][193] =  6.2; gotoh_bp[5][195] =  4.6; gotoh_bp[5][199] =  2.4; gotoh_bp[5][213] =  5.9;
  gotoh_bp[5][321] =  1.3; gotoh_bp[5][323] =  1.;  gotoh_bp[5][327] =  0.2; gotoh_bp[5][341] =  5.1;
  gotoh_bp[5][449] =  7.5; gotoh_bp[5][451] =  0.6; gotoh_bp[5][455] =  4.9; gotoh_bp[5][469] =  2.4;
  /* type 6 -> tWS */
  gotoh_bp[6][65]  =  4.4; gotoh_bp[6][67]  =  1.6; gotoh_bp[6][71]  = 57.4; gotoh_bp[6][85]  =  1.3;
  gotoh_bp[6][193] =  0.1; gotoh_bp[6][195] =  6.1; gotoh_bp[6][199] =  4.4; gotoh_bp[6][213] =  0.3;
  gotoh_bp[6][321] =  0.;  gotoh_bp[6][323] =  3.5; gotoh_bp[6][327] =  0.;  gotoh_bp[6][341] =  9.5;
  gotoh_bp[6][449] =  6.0; gotoh_bp[6][451] =  2.8; gotoh_bp[6][455] =  1.2; gotoh_bp[6][469] =  1.1;
  /* type 7 -> cHH */
  gotoh_bp[7][65]  =  0.;  gotoh_bp[7][67]  =  0.;  gotoh_bp[7][71]  = 49.6; gotoh_bp[7][85]  =  0.;
  gotoh_bp[7][193] =  0.;  gotoh_bp[7][195] =  0.;  gotoh_bp[7][199] =  0.;  gotoh_bp[7][213] =  0.;
  gotoh_bp[7][321] = 49.6; gotoh_bp[7][323] =  0.;  gotoh_bp[7][327] = 50.;  gotoh_bp[7][341] =  0.;
  gotoh_bp[7][449] =  0.;  gotoh_bp[7][451] =  0.;  gotoh_bp[7][455] =  0.;  gotoh_bp[7][469] =  0.;
  /* type 8 -> tHH */
  gotoh_bp[8][65]  = 70.6; gotoh_bp[8][67]  =  5.3; gotoh_bp[8][71]  =  8.5; gotoh_bp[8][85]  =  5.0;
  gotoh_bp[8][193] =  5.3; gotoh_bp[8][195] =  0.;  gotoh_bp[8][199] =  0.7; gotoh_bp[8][213] =  4.7;
  gotoh_bp[8][321] =  8.5; gotoh_bp[8][323] =  0.7; gotoh_bp[8][327] =  4.3; gotoh_bp[8][341] =  0.;
  gotoh_bp[8][449] =  5.0; gotoh_bp[8][451] =  4.7; gotoh_bp[8][455] =  0.;  gotoh_bp[8][469] =  0.;
  /* type 9 -> cHS */
  gotoh_bp[9][65]  = 15.6; gotoh_bp[9][67]  =  1.;  gotoh_bp[9][71]  =  1.5; gotoh_bp[9][85]  = 10.1;
  gotoh_bp[9][193] =  4.9; gotoh_bp[9][195] =  0.6; gotoh_bp[9][199] =  3.0; gotoh_bp[9][213] =  8.6;
  gotoh_bp[9][321] =  1.6; gotoh_bp[9][323] =  0.;  gotoh_bp[9][327] =  0.2; gotoh_bp[9][341] =  0.;
  gotoh_bp[9][449] =  1.;  gotoh_bp[9][451] =  1.4; gotoh_bp[9][455] = 46.9; gotoh_bp[9][469] =  3.;
  /* type 10 -> tHS */
  gotoh_bp[10][65]  =  8.7; gotoh_bp[10][67]  =  1.5; gotoh_bp[10][71]  = 69.;  gotoh_bp[10][85]  =  8.0;
  gotoh_bp[10][193] =  1.3; gotoh_bp[10][195] =  0.2; gotoh_bp[10][199] =  0.;  gotoh_bp[10][213] =  0.4;
  gotoh_bp[10][321] =  0.;  gotoh_bp[10][323] =  0.;  gotoh_bp[10][327] =  3.5; gotoh_bp[10][341] =  0.;
  gotoh_bp[10][449] =  2.3; gotoh_bp[10][451] =  0.;  gotoh_bp[10][455] =  3.6; gotoh_bp[10][469] =  0.;
   /* type 11 -> cSS */
  gotoh_bp[11][65]  =  7.9; gotoh_bp[11][67]  = 28.1; gotoh_bp[11][71]  =  7.7; gotoh_bp[11][85]  =  1.6;
  gotoh_bp[11][193] = 23.;  gotoh_bp[11][195] =  0.1; gotoh_bp[11][199] =  1.6; gotoh_bp[11][213] =  0.8;
  gotoh_bp[11][321] =  8.5; gotoh_bp[11][323] =  0.2; gotoh_bp[11][327] =  1.4; gotoh_bp[11][341] =  2.2;
  gotoh_bp[11][449] = 12.2; gotoh_bp[11][451] =  0.4; gotoh_bp[11][455] =  4.1; gotoh_bp[11][469] =  0.2;
   /* type 12 -> tSS */
  gotoh_bp[12][65]  =  5.9; gotoh_bp[12][67]  = 17.9; gotoh_bp[12][71]  = 62.1; gotoh_bp[12][85]  =  4.5;
  gotoh_bp[12][193] =  0.;  gotoh_bp[12][195] =  0.;  gotoh_bp[12][199] =  0.;  gotoh_bp[12][213] =  0.;
  gotoh_bp[12][321] =  1.1; gotoh_bp[12][323] =  1.5; gotoh_bp[12][327] =  4.6; gotoh_bp[12][341] =  1.1;
  gotoh_bp[12][449] =  0.;  gotoh_bp[12][451] =  0.;  gotoh_bp[12][455] =  0.;  gotoh_bp[12][469] =  0.;
  
  return;
  
}

/* -------------------------------------------------------------------------- */

void gotoh_fwRecursionMotifSingle(char *db_seq, int n, struct gotoh_motifSingle motif,
				  struct farray *scores, int *score_histo, struct gotoh_settings cfg,
				  char strand) {

/* void gotoh_fwRecursionMotifSingle(struct farray * scores, char *db_seq, int n, gotoh_motifSingle motif, */
/* 				  char *db_name, int *score_histo, int n_s, gotoh_settings cfg, int n2add, char strand) { */

  int  i,j, m;
  float transf_score;/* , *score; */
  float p,pp;
  float *S, *S_, *D, *D_, *F, *F_, *tmp;
  int *itmp, *G, *G_;
  float minAS, tmpscore, gap_penalty=1;
  /* char *tmpdb=NULL,*tmpqu=NULL; */
  
  /* score distribution over database */
  
  m = motif.len;

  /* tmpdb = (char *) calloc(m+2, sizeof(char)); */
  /* tmpqu = (char *) calloc(m+2, sizeof(char)); */
  
  S   = (float *) calloc(m+1, sizeof(float));
  S_  = (float *) calloc(m+1, sizeof(float));
  D   = (float *) calloc(m+1, sizeof(float));
  D_  = (float *) calloc(m+1, sizeof(float));
  F   = (float *) calloc(m+1, sizeof(float));
  F_  = (float *) calloc(m+1, sizeof(float));
  G   = (int *) calloc(m+1, sizeof(int)); /* save number of gaps */
  G_  = (int *) calloc(m+1, sizeof(int));

  minAS = abs( 2 * (cfg.gap_open + ((m - 1) * cfg.gap_extend)));
  
  /* initialize semi-local alignment */
  D_[0] = -(cfg.inf);
  F_[0] = -(cfg.inf);
  S_[0] = 0;
  G_[0] = 0;

  for(j=1;j<=m;j++) { 
    D_[j] = -(cfg.inf);
    F_[j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S_[j] = F[j];
    G_[j] = j;
  }

  for(i=1;i<=n;i++) {
    if(i%1000==0 && cfg.quiet == 0) {
      fprintf(stderr, "\r#    %-5.2f %% (db length: %d) %c strand", (float) (i)/ (float) (n) * 100, n, strand);
      fflush(stderr);
    }
    /* init */
    D[0] = 0;  /* local alignment!*/
    F[0] = -cfg.inf;
    S[0] = 0;
    G[0] = 0;

    /* printf("fw: "); */
    /* align query  against each database position i */
    for(j=1;j<=m;j++) {
      /* tmpdb[j] = db_seq[i-1]; */
      /* tmpqu[j] = motif.max[j-1]; */
      /* adjust gap penalty to 1-freq(gap,i) */
      /* gap_penalty = 1 - (motif.info[j-1]*motif.freq[4][j-1]-motif.min[j-1]*motif.info[j-1])/(motif.max[j-1]*motif.info[j-1]-motif.min[j-1]*motif.info[j-1]); */
      gap_penalty = 1;

      p  = S[j-1] + cfg.gap_open * gap_penalty;
      pp = D[j-1] + cfg.gap_extend * gap_penalty;
      if(p>pp) D[j] = p;   /* start new insertion */
      else D[j] = pp;      /* extend insertion    */
      
      p = S_[j]  + cfg.gap_open;
      pp = F_[j]  + cfg.gap_extend;
      if(p>pp) F[j] = p;   /* start new deletion */
      else F[j] = pp;      /* extend deletion    */
      
      p = S_[j-1];

      /* get match/mismatch score from motif matrices */
      tmpscore = gotoh_scoreMotif((unsigned char)db_seq[i-1], motif.freq, motif.min, motif.max, motif.info, j-1);

      if(tmpscore > cfg.m1_seqT) { /* ==> regarded as match, max is 1 */
	p += tmpscore * cfg.match;
      } else {
	p += tmpscore * cfg.mismatch;
      }

      pp = maxF(maxF(F[j],D[j]),p);

      if(pp == p) { G[j] = G_[j-1]; }
      else if(pp == F[j]) { G[j] = G_[j] + 1;}
      else if(pp == D[j]) { G[j] = G[j-1] + 1; }

      S[j] = pp; continue;
      
      /* older version */
      if(D[j]>p) p=D[j];                   /* insertion */
      if(F[j]>p) p=F[j];                   /* deletion  */
      
      S[j] = p;

      /* printf("[%8d:%8d]=(%6.2f, %6.2f, %6.2f)\t",i%m,j,D[j],F[j],S[j]); */

    }
    /* printf("\n"); */

    /* tmpdb[j] = '\0'; */
    /* tmpqu[j] = '\0'; */
    /* printf("S:%8d\t %s %s\n",tmpdb,tmpqu); */
    
    transf_score = S[m] + minAS;
    
    scores->vals[i-1] = transf_score; /* achtung seq starts with 0 */

    /* scores->vals[i-1] = S[m];  */       /* position on db with score, starts with 0! not 1 */

    scores->start[i-1]  = i - 1 - m - G[m] + 1;    /* start position with score */
    
    score_histo[(int)(transf_score+0.5)]++; /* sum up to transformed score distribution */

    /* rotate memory */
    tmp = S_; S_ = S; S = tmp;
    tmp = D_; D_ = D; D = tmp;
    tmp = F_; F_ = F; F = tmp;
    itmp = G_; G_ = G; G = itmp;
    
  }

  if(cfg.quiet == 0) {
    fprintf(stderr, "\r#    %-5.2f %% (db length: %d) %c strand",  100., n, strand);
    fflush(stderr);
  }
  free(S);free(S_);free(D);free(D_);free(F);free(F_);free(G);free(G_);

  return;

}

/* -------------------------------------------------------------------------- */
/* find all local maxima, set scores in region around it to zero */
/* insert lm in list, return sum > 0 or 0 if list is zero or last lm found */
/* float gotoh_getLocalMaxMotif(struct farray *scores, struct gotoh_motifSingle mS, */
/* 			     struct gotoh_aln List[], struct gotoh_settings gs, */
/* 			     char *db_seq, char *db_name, char strand, struct iarray *lm) { */

/*   int i, ii, maxI, maxSint; */
/*   float sum=0, minS, maxS, shift; */
  
/*   minS = -gs.inf; */
/*   maxI = 0; */
/*   maxS = minS; */

/*   shift = abs( 2 * (gs.gap_open + ((mS.len - 1) * gs.gap_extend))); */
  
/*   /\* find LM *\/ */
/*   for(i=0; i<scores->size; i++)  */
/*     if(scores->vals[i] > maxS) { */
/*       maxS = scores->vals[i]; */
/*       maxI = i; */
/*     } */


/*   /\* transform score *\/ */
/*   maxSint = (int) (maxS + 0.5);  */
/*   lm->vals[maxSint] += 1; */
/*   printf("MLF%c %d %.2f %d\n",strand, maxI, maxS- shift, maxSint); */
  
/*   /\* insert LM into List *\/ */
/*   ii = 0; /\* find place in L to put local maxima *\/ */
/*   while(List[ii].alnscore > maxS && ii < MAX_ALNS) ii++; */
/*   if(ii == MAX_ALNS) return 0; */
/*   gotoh_backtraceAlnMotifSingle(ii, maxI, maxS, strand, db_name, db_seq, mS, List, 0, gs, scores); */
  
/*   /\* set region around LM to -inf *\/ */
/*   for(i=0; i<scores->size; i++) {  */
/*     if(i>=maxI-(2*mS.len) && i<=maxI+(2*mS.len))  */
/*       scores->vals[i] = 0; */
/*     sum += scores->vals[i]; */
/*   } */
  
/*   return sum; */
  
/* } */

/* -------------------------------------------------------------------------- */

void gotoh_findLocalMaximaMotifSingle(struct farray *scores, gotoh_aln List[], int s, int e,
				      char *db_seq, char *db_name, gotoh_motifSingle mS,
				      char strand, struct gotoh_settings gs, struct iarray *lm, int db_len) {

/* void gotoh_findLocalMaximaMotifSingle(struct farray * scores, gotoh_aln List[], int n2add, int s, int e, */
/* 				      char *db_seq, char *db_name, gotoh_motifSingle mS, char strand, */
/* 				      gotoh_settings gs, int Len, int *score_histo, int n_s, struct iarray *lm) */

  float maxS;
  int maxSint, maxI, nsl, nel, nsr, ner, ii, m, newend=0;

  m = mS.len;

  if(s < 0 || e >= db_len) return;
  if(e - s < m) return;
    
  gotoh_getMaxLinearF(scores, s, e, &maxS, &maxI);
  maxSint = (int) (maxS*10 + 0.5); /* transformed score */
  lm->vals[maxSint] += 1;
  
  /* fprintf(stderr,"SE %d %d %.2f at pos:%d\t(%c) ",s,e,maxS, maxI,strand); */

  ii = 0; /* find place in L to put local maxima */
  
  while(List[ii].alnscore > maxS && ii < MAX_ALNS) ii++;

  if(ii == MAX_ALNS) return; /* list already full with scores all > maxS ! */

  /* backtrace aln with score maxS at maxI in db, insert it into List at ii */
  newend = gotoh_backtraceAlnMotifSingle(ii, maxI, maxS, strand, db_name, db_seq, mS, List, s, gs, scores);

  if(newend == -1) return;
  
  /* fprintf(stderr, "newend: %d newstart:%d\n", newend, maxI+m+1); */

  /* fprintf(stderr,"s: %d newend: %d maxI: %d e: %d\n", s, newend, maxI, e); */
  
  /* d&c recursion on left side */
  /* nsl = s; nel = maxI - 2*m; */
  nsl = s;
  nel = newend - 1;
  if(nel - nsl >= m)
    gotoh_findLocalMaximaMotifSingle(scores, List, nsl, nel, db_seq, db_name, mS, strand, gs, lm, db_len);
  
  /* d&c recursion on right side */
  /* nsr = maxI + 2*m; ner = e; */
  nsr = maxI + m + 1;
  ner = e;
  if(ner - nsr >= m)
    gotoh_findLocalMaximaMotifSingle(scores, List, nsr, ner, db_seq, db_name, mS, strand, gs, lm, db_len);
  
  return;

}


/* -------------------------------------------------------------------------- */

void gotoh_getMaxLinearF(struct farray *scores, int s, int e, float *maxS, int *maxI) {

  int i, im=-1, j, k;
  float sm=0., prev;

  i=s;
  prev = scores->vals[i];
  while(scores->vals[i] <= prev && i<=e && i<scores->size) {
    prev = scores->vals[i];
    i++;
  }

  j=e;
  prev = scores->vals[j];
  while(scores->vals[j] <= prev && j>=s && j>=0) {
    prev = scores->vals[j];
    j--;
  }

  if(i>=j) return;
  
  for(k=i; k<=j; k++) {
    if(scores->vals[k] >= sm) {
      sm = scores->vals[k];
      im = k;
    }
  }

  *maxS = sm; *maxI = im;
  
  return;
  
  
}

/* -------------------------------------------------------------------------- */

int gotoh_backtraceAlnMotifSingle(int ii, int maxI, float maxS, char strand, char *db_name,
				   char *db_seq, gotoh_motifSingle mS, gotoh_aln List[],
				   int n2add, gotoh_settings gs, struct farray *scores) {

  float *bt;
  struct gotoh_aln curaln;
  int m, shift,  g, start, sA, eA;

  m = mS.len;
  int Len = scores->size;
  sA = scores->start[maxI];
  if(sA < 0) sA = 0;
  eA = maxI;
  
  shift = abs(2 * (gs.gap_open + (m-1) * gs.gap_extend));
  
  curaln = gotoh_initL();
  curaln.alnscore = maxS;
  curaln.shift = shift;
  curaln.ntfalnscore = maxS - shift;
  curaln.db_len = Len;
  curaln.qStart = 1;
  curaln.qEnd = m;
  curaln.strand = strand;
  curaln.hitname = (char *) calloc(strlen(db_name)+1, sizeof(char));
  strcpy(curaln.hitname, db_name);
  curaln.queryname = (char *) calloc(strlen(mS.name)+1, sizeof(char));
  strcpy(curaln.queryname, mS.name);
  curaln.hitseq = (char *) calloc(4*m+1, sizeof(char));
  curaln.queryseq = (char *) calloc(2*m+1, sizeof(char));

  bt = gotoh_bwRecursionMotifSingle2(db_seq, mS, maxI, gs, curaln.hitseq, curaln.queryseq, curaln.ntfalnscore, n2add, sA, eA);

  if(bt == NULL) return -1;
 
  curaln.percID = bt[0]; curaln.mismatches = (int) bt[1];
  curaln.gapopening = (int) bt[2]; curaln.length = (int) bt[3];
  if(strand == '-') {
    /* curaln.sStart = Len - ( n2add + (int) bt[5]); */
    /* curaln.sEnd   = Len - ( n2add + (int) bt[4]); */
    curaln.sStart = Len - (int)(bt[5]);
    curaln.sEnd   = Len - (int)(bt[4]);
  } else {
    /* curaln.sStart = n2add + (int) bt[4]; */
    /* curaln.sEnd   = n2add + (int) bt[5]; */
    curaln.sStart = (int)(bt[4]);
    curaln.sEnd   = (int)(bt[5]);
  }
  curaln.evalue = -1;
  start = (int)(bt[4]);
  free(bt);

  /* don't insert duplicated entry (due to splits system!) */
  if(ii>=1 && List[ii-1].alnscore == curaln.alnscore && List[ii-1].sEnd == curaln.sEnd) {
    /* return; */
    return start;
  }

  if(List[ii].alnscore == -1) {
    List[ii] = curaln;
    return start;
    /* return; */
  }
  
  for(g=MAX_ALNS-1; g>ii; g--) {
    if(List[g-1].alnscore == -1) continue;

    List[g] = List[g-1];
    
  }
  List[ii] = curaln;

  return start;
  /* return; */

}

/* -------------------------------------------------------------------------- */

float * gotoh_bwRecursionMotifSingle2(char *db_seq, gotoh_motifSingle mS, int s_pos, gotoh_settings cfg,
				      char *ss, char *qq, float sollscore, int n2add,
				      int sA, int eA) {

  int m, i,j,k,len;
  float **S, **D, **F, tmpscore, p, pp;
  char *sa, *qa, /* *sx, */ btstate;
  char *db_part=NULL;
  char *q=NULL;
  int si,qj,found, start,gos,mms,perc,gquery;
  float *res, epsilon=0.001, gap_penalty=1;
  int db_end;

  m = mS.len;

  if(sA < 0) sA = 0;
  len = eA - sA + 1;

  db_part = (char *)strndup(db_seq+sA, len);/* printf("db: %s\n", db_part); */

  int minAS = abs( 2 * (cfg.gap_open + ((m - 1) * cfg.gap_extend)));

  /* printf("sollscore: %d  ",sollscore); */
  sollscore -= (float) minAS;
  /* printf("retransformed: %d\n", sollscore); */

  /* fprintf(stderr, "BW s_pos: %d m: %d n2add: %d\n",s_pos,m,n2add); */
  
  /* len = 2 * m + 1; */
  /* /\* len must not exceed 0 *\/ */
  /* if(len > s_pos) len = s_pos + 1; */
  /* /\* minstart of alignment (=len) must not exceed n2add! *\/ */
  /* if(s_pos - len < n2add) len = s_pos - n2add; */
  /* if(len <= m) return NULL; */
  
  /* fprintf(stderr,"\n\tm=%d 2*m+1=%d s_pos=%d final-len=%d  sollscore: %.2f\n",m, 2*m+1, s_pos, len, sollscore); */
  
  /* retransform score */
  /* int wc; wc = abs(2*(cfg.gap_open + (m-1)*cfg.gap_extend)); */
  /* sollscore -= wc; */
  
  S = (float **) calloc(len+1, sizeof(float *));
  D = (float **) calloc(len+1, sizeof(float *));
  F = (float **) calloc(len+1, sizeof(float *));
  for(i=0;i<=len;i++) {
    S[i] = (float *) calloc(m+1, sizeof(float *));
    D[i] = (float *) calloc(m+1, sizeof(float *));
    F[i] = (float *) calloc(m+1, sizeof(float *));
  }
  sa = (char *) calloc(m+len+1, sizeof(int *));
  qa = (char *) calloc(m+len+1, sizeof(int *));

  q = (char *) calloc(m+1, sizeof(char));
  strcpy(q, mS.maxC);
  
  D[0][0] = (-cfg.inf);
  F[0][0] = (-cfg.inf);
  S[0][0] = 0;

  for(j=1;j<=m;j++) { 
    D[0][j] = (-cfg.inf);
    F[0][j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S[0][j] = F[0][j];
  }

  /* do forward recursion again */
  for(i=1;i<=len;i++) {
    si =  sA + i - 1;/*s_pos-(i-1);*/
    
    D[i][0] = 0;
    F[i][0] = (-cfg.inf);
    S[i][0] = 0;

    /* printf("bw: "); */
    for(j=1;j<=m;j++) {
      qj = j-1; /*m-j;	 */

      /* gap_penalty = 1 - (mS.info[qj]*mS.freq[4][qj]-mS.min[qj]*mS.info[qj])/(mS.max[qj]*mS.info[qj]-mS.min[qj]*mS.info[qj]); */
      gap_penalty = 1;
            
      p  = S[i][j-1] + cfg.gap_open * gap_penalty;
      pp = D[i][j-1] + cfg.gap_extend * gap_penalty;
      D[i][j] = p > pp ? p : pp;
      
      p  = S[i-1][j] + cfg.gap_open;
      pp = F[i-1][j] + cfg.gap_extend;
      F[i][j] = p > pp ? p : pp;

      p = S[i-1][j-1];

      tmpscore = gotoh_scoreMotif((unsigned char)db_seq[si], mS.freq, mS.min, mS.max, mS.info, qj);

      if(tmpscore > cfg.m1_seqT) { /* ==> regarded as match, max is 1 */
	p += (tmpscore * cfg.match);
      } else {
	p += (tmpscore * cfg.mismatch);
      }
      
      if(D[i][j]>p) p=D[i][j];      
      if(F[i][j]>p) p=F[i][j];
      
      S[i][j] = p;

      /* printf("[%8d:%8d]=(%6.2f, %6.2f, %6.2f)\t",i,j,D[i][j],F[i][j],S[i][j]); */
      
    }
    /* printf("\n"); */
  }

  /* check matrices */
  /* printf("\n"); */
  /* for(i=0; i<=len; i++) { */
  /*   printf("%3d:\t",i); */
  /*    for(j=0; j<=m; j++) { */
  /*     printf("[%3d:%3d]={%5.2f,%5.2f,%5.2f}          ",i,j,S[i][j],D[i][j],F[i][j]); */
  /*   } */
  /*    printf("\n"); */
  /* } */
  /* printf("sollscore: %f\n", sollscore); */
  /* ^^^ */

  int maxS = S[0][m];
  int maxI = 0;
  i = len;

  while(i>=1) {
    if(S[i][m] > maxS) {
      maxI = i; maxS = S[i][m];
    }
    i--;
  }

  
  /* find (old) sollscore in S from (new) forward recursion */
  /* =len; found = 0; */
  /* float maxscore = sollscore; */
  /* int maxscoreI=0; */
  /* while(i>=1) { */
  /*   if(fabs(S[i][m] - sollscore) < epsilon) { */
  /*     /\* maxscore = sollscore; *\/ */
  /*     maxscoreI = i; */
  /*     break; */
  /*   } else if(S[i][m] > maxscore) { */
  /*     maxscore = S[i][m]; */
  /*     maxscoreI = i; */
  /*   } */
  /*   i--; */
  /* } */

  /* if(i == 0 && len < 2*m+1) { /\* in this case, it overlaps with a better candidate *\/ */
  /*   return NULL; */
  /*   fprintf(stderr, "sollscore %.2f not found in [%d:%d]\n",sollscore,s_pos-len,s_pos); exit(0); */
  /* } */
  
  /* i = maxscoreI; */
  /* if(maxscore != sollscore) { */
  /*   fprintf(stderr, "NOTE: At position %d a better alignment then the requested one ",maxscoreI+n2add); */
  /*   fprintf(stderr, "at %d is possible. ",s_pos); */
  /*   fprintf(stderr, "Distance: |%f-%f| = %f\n",maxscore,sollscore, fabs(maxscore-sollscore)); */
  /* } */
  
  /* /\* fprintf(stderr, "final i: %d\n", i); *\/ */
  /* if(i==-1) { */
  /*   fprintf(stderr, "sollscore and nothing better found\n"); */
  /*   exit(0); */
  /* } */
  /* /\* istscore = S[i][m]; *\/ */
  /* /\* printf("istscore: %f at %d %d found: %d\n", istscore,i,m,found); *\/ */

  
  /* /\* printf("sollscore: %f %i foundscore: %f found %d\n", sollscore, i, S[i][m], found); *\/ */
  /* /\* fflush(stderr); *\/ */
  /* /\* exit(0); *\/ */
  
  /* /\* int realend = i; *\/ */
  /* /\* if(s_pos == 2251) { fprintf(stderr, "s_pos: %d realend-i: %d maxscoreI: %d len: %d\n",s_pos,i,maxscoreI,len); exit(0); } *\/ */
    
  /* start = s_pos-i+1; */
  /* db_end = start; */

  res = (float *) calloc(7, sizeof(float));
  /* percId, mm, go, length */
  gos = 0;
  mms = 0;
  perc = 0;
  gquery = 0;

  i = maxI;
  j = m;
  k = 0;
  btstate = 'S';

  /* printf("\n%s\n%s\n",db_part,q); */
  
  while( (j>1) ) {

    if(i<1) break;
    
    si = i-1; /* s_pos -(i-1); */
    qj = j-1; /* m -j; */

    /* if(si < 0) { */
    /*   while(j>0) { */
    /* 	sa[k] = '-'; */
    /* 	qa[k] = q[qj]; */
    /* 	start++; */
    /* 	j--; */
    /* 	k++; */
    /* 	qj = m -j; */
    /* 	si = 1; */
    /*   } */
    /*   break; */
    /* } */
    
    gap_penalty = 1;

    switch(btstate) {
    case 'S':
      tmpscore = gotoh_scoreMotif(db_part[si], mS.freq, mS.min, mS.max, mS.info, qj);
      /* fprintf(stderr, "tmpscore: %.2f\n",tmpscore); */
      if(tmpscore > cfg.m1_seqT) {
	p = tmpscore * cfg.match;
      }
      else {
	p = tmpscore * cfg.mismatch;
      }

      /* fprintf(stderr, "%d:%c %d:%c = %d\n",i,db_part[si],j,q[qj],p); */
      p += S[i-1][j-1];
      
      if(fabs(S[i][j] - p) < epsilon) {
	sa[k] = db_seq[si];
	qa[k] = q[qj];
	db_end++;
	i--;
	j--;
	k++;
	btstate = 'S';
	if(tmpscore > cfg.m1_seqT) 
	  perc++;
	else
	  mms++;
	
      } else if( fabs(S[i][j] - F[i][j]) < epsilon ) {
	btstate = 'F';
      } else if( fabs(S[i][j] - D[i][j]) < epsilon ) {
	btstate = 'D';
      } else {
	fprintf(stderr,"This should not happen in S[%d][%d]=%f (Bw motif single 1)\n",i,j,S[i][j]);
	fprintf(stderr,"S[%d][%d]=%f\tF=%f\tD=%f\n",i,j,S[i][j],F[i][j],D[i][j]);
	fprintf(stderr,"S[%d][%d]=%f\tF=%f\tD=%f\n",i-1,j-1,S[i-1][j-1],F[i-1][j-1],D[i-1][j-1]);
	fprintf(stderr,"S[%d][%d]=%f\tF=%f\tD=%f\n",i,j-1,S[i][j-1],F[i][j-1],D[i][j-1]);
	fprintf(stderr,"S[%d][%d]=%f\tF=%f\tD=%f\n",i-1,j,S[i-1][j],F[i-1][j],D[i-1][j]);
	exit(0);
      } 
      break;
    case 'D':
      /* if(q[qj] == '-')  */
      /* if(mS.freq[4][qj] != 0)  */
	/* gap_penalty = 1 - (mS.info[qj]*mS.freq[4][qj]-mS.min[qj]*mS.info[qj])/(mS.max[qj]*mS.info[qj]-mS.min[qj]*mS.info[qj]); */
      /* else */
      	gap_penalty = 1;
      if( fabs(D[i][j] - (S[i][j-1] + cfg.gap_open * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
        j--;	
	k++;
	btstate = 'S';
	gos++;
      }	else if( fabs(D[i][j] - (D[i][j-1] + cfg.gap_extend * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
	j--;
	k++;
	btstate = 'D';
      } else {
	fprintf(stderr,"This should not happen in (Bw motif single 2)\nD[%d][%d]=%f \n",i,j,D[i][j]);
	fprintf(stderr,"S[%d][%d]=%f\n",i,j-1,S[i][j-1]+ cfg.gap_open * gap_penalty);
	fprintf(stderr,"D[%d][%d]=%f\n",i,j-1,D[i][j-1]+ cfg.gap_extend * gap_penalty);
	fprintf(stderr, "gap_penalty=%f sollscore=%f\n", gap_penalty, sollscore);
	exit(0);
      } 
      break;
    case 'F':
      if( fabs(F[i][j] - (S[i-1][j] + cfg.gap_open)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'S';
	gos++;
	gquery++;
      } else if ( fabs(F[i][j] - (F[i-1][j]  + cfg.gap_extend)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'F';
	gquery++;
      } else {
	fprintf(stderr,"This should not happen in F[%d][%d]=%f (Bw motif singel 3)\n",i,j,F[i][j]);
	exit(0);
      }    
      break;
    default:
      fprintf(stderr,"This should not happen at all. btstate: %c\n",btstate);
      exit(0);
    }
    
  }  


  k = strlen(sa);
  
  res[0] = (float) perc / (float) m * 100;
  res[1] = (float) mms;
  res[2] = (float) gos;
  res[3] = (float) k;
  /* res[4] = (float) s_pos - (realend-1) + 1; */
  /* res[5] = (float) si + 1; */
  res[4] = s_pos - perc - mms - gquery + 2; 
  res[5] = s_pos + 1;

  /* fprintf(stderr, "\tbt[4]:%d (perc: %d mms: %d)\t", (int)(res[4]),perc, mms); */
  
  strcpy(ss, sa);
  strcpy(qq, qa);

  for(i=0;i<=len;i++) {
    if(S[i]) free(S[i]);  if(D[i]) free(D[i]); if(F[i]) free(F[i]);
  }
  if(S) free(S); if(D) free(D); if(F) free(F);
  if(qa) free(qa);
  if(sa) free(sa);
  if(q) free(q);
  
  free(db_part);

  return res;

}

/* -------------------------------------------------------------------------- */

float * gotoh_bwRecursionMotifSingle(char *db_seq, gotoh_motifSingle mS, int s_pos,
				     gotoh_settings cfg,
				     char *ss, char *qq, float sollscore, int n2add) {

  int m, i,j,k,len;
  float **S, **D, **F, tmpscore, p, pp;
  char *sa, *qa, /* *sx, */ btstate;
  char *q=NULL;
  int si,qj,found, start,gos,mms,perc,gquery;
  float *res, epsilon=0.001, gap_penalty=1;
  int db_end;

  m = mS.len;

  /* fprintf(stderr, "BW s_pos: %d m: %d n2add: %d\n",s_pos,m,n2add); */
  
  len = 2 * m + 1;
  /* len must not exceed 0 */
  if(len > s_pos) len = s_pos + 1;
  /* minstart of alignment (=len) must not exceed n2add! */
  if(s_pos - len < n2add) len = s_pos - n2add;
  if(len <= m) return NULL;
  
  /* fprintf(stderr,"\n\tm=%d 2*m+1=%d s_pos=%d final-len=%d  sollscore: %.2f\n",m, 2*m+1, s_pos, len, sollscore); */
  
  /* retransform score */
  /* int wc; wc = abs(2*(cfg.gap_open + (m-1)*cfg.gap_extend)); */
  /* sollscore -= wc; */
  
  S = (float **) calloc(len+1, sizeof(float *));
  D = (float **) calloc(len+1, sizeof(float *));
  F = (float **) calloc(len+1, sizeof(float *));
  for(i=0;i<=len;i++) {
    S[i] = (float *) calloc(m+1, sizeof(float *));
    D[i] = (float *) calloc(m+1, sizeof(float *));
    F[i] = (float *) calloc(m+1, sizeof(float *));
  }
  sa = (char *) calloc(2*m+len+1, sizeof(int *));
  qa = (char *) calloc(2*m+len+1, sizeof(int *));

  q = (char *) calloc(m+1, sizeof(char));
  strcpy(q, mS.maxC);
  
  D[0][0] = (-cfg.inf);
  F[0][0] = (-cfg.inf);
  S[0][0] = 0;

  for(j=1;j<=m;j++) { 
    D[0][j] = (-cfg.inf);
    F[0][j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S[0][j] = F[0][j];
  }

  /* do forward recursion again */
  for(i=1;i<=len;i++) {
    si = s_pos-(i-1);
    
    D[i][0] = 0;
    F[i][0] = (-cfg.inf);
    S[i][0] = 0;

    /* printf("bw: "); */
    for(j=1;j<=m;j++) {
      qj = m-j;	 

      /* gap_penalty = 1 - (mS.info[qj]*mS.freq[4][qj]-mS.min[qj]*mS.info[qj])/(mS.max[qj]*mS.info[qj]-mS.min[qj]*mS.info[qj]); */
      gap_penalty = 1;
            
      p  = S[i][j-1] + cfg.gap_open * gap_penalty;
      pp = D[i][j-1] + cfg.gap_extend * gap_penalty;
      D[i][j] = p > pp ? p : pp;
      
      p  = S[i-1][j] + cfg.gap_open;
      pp = F[i-1][j] + cfg.gap_extend;
      F[i][j] = p > pp ? p : pp;

      p = S[i-1][j-1];

      tmpscore = gotoh_scoreMotif((unsigned char)db_seq[si], mS.freq, mS.min, mS.max, mS.info, qj);

      if(tmpscore > cfg.m1_seqT) { /* ==> regarded as match, max is 1 */
	p += (tmpscore * cfg.match);
      } else {
	p += (tmpscore * cfg.mismatch);
      }
      
      if(D[i][j]>p) p=D[i][j];      
      if(F[i][j]>p) p=F[i][j];
      
      S[i][j] = p;

      /* printf("[%8d:%8d]=(%6.2f, %6.2f, %6.2f)\t",i,j,D[i][j],F[i][j],S[i][j]); */
      
    }
    /* printf("\n"); */
  }

  /* check matrices */
  /* printf("\n"); */
  /* for(i=0; i<=len; i++) { */
  /*   printf("%3d:\t",i); */
  /*    for(j=0; j<=m; j++) { */
  /*     printf("[%3d:%3d]={%5.2f,%5.2f,%5.2f}          ",i,j,S[i][j],D[i][j],F[i][j]); */
  /*   } */
  /*    printf("\n"); */
  /* } */
  /* printf("sollscore: %f\n", sollscore); */
  /* ^^^ */

  /* find (old) sollscore in S from (new) forward recursion */
  i=len; found = 0;
  float maxscore = sollscore;
  int maxscoreI=0;
  while(i>=1) {
    if(fabs(S[i][m] - sollscore) < epsilon) {
      /* maxscore = sollscore; */
      maxscoreI = i;
      break;
    } else if(S[i][m] > maxscore) {
      maxscore = S[i][m];
      maxscoreI = i;
    }
    i--;
  }

  if(i == 0 && len < 2*m+1) { /* in this case, it overlaps with a better candidate */
    return NULL;
    fprintf(stderr, "sollscore %.2f not found in [%d:%d]\n",sollscore,s_pos-len,s_pos); exit(0);
  }
  
  i = maxscoreI;
  if(maxscore != sollscore) {
    fprintf(stderr, "NOTE: At position %d a better alignment then the requested one ",maxscoreI+n2add);
    fprintf(stderr, "at %d is possible. ",s_pos);
    fprintf(stderr, "Distance: |%f-%f| = %f\n",maxscore,sollscore, fabs(maxscore-sollscore));
  }
  
  /* fprintf(stderr, "final i: %d\n", i); */
  if(i==-1) {
    fprintf(stderr, "sollscore and nothing better found\n");
    exit(0);
  }
  /* istscore = S[i][m]; */
  /* printf("istscore: %f at %d %d found: %d\n", istscore,i,m,found); */

  
  /* printf("sollscore: %f %i foundscore: %f found %d\n", sollscore, i, S[i][m], found); */
  /* fflush(stderr); */
  /* exit(0); */
  
  /* int realend = i; */
  /* if(s_pos == 2251) { fprintf(stderr, "s_pos: %d realend-i: %d maxscoreI: %d len: %d\n",s_pos,i,maxscoreI,len); exit(0); } */
    
  start = s_pos-i+1;
  db_end = start;

  res = (float *) calloc(7, sizeof(float));
  /* percId, mm, go, length */
  gos = 0;
  mms = 0;
  perc = 0;
  gquery = 0;
  
  j = m;
  k = 0;
  btstate = 'S';
  
  while( (j>0) ) {

    if(i<1) break;
    
    si = s_pos -(i-1);
    qj = m -j;

    if(si < 0) {
      while(j>0) {
	sa[k] = '-';
	qa[k] = q[qj]; 
	start++;
	j--;
	k++;
	qj = m -j;
	si = 1;
      }
      break;
    }
    
    gap_penalty = 1;

    switch(btstate) {
    case 'S':
      p = S[i-1][j-1];
      tmpscore = gotoh_scoreMotif(db_seq[si], mS.freq, mS.min, mS.max, mS.info, qj);
      if(tmpscore > cfg.m1_seqT) {
	p += tmpscore * cfg.match;
      }
      else {
	p += tmpscore * cfg.mismatch;
      }

      if(fabs(S[i][j] - p) < epsilon) {
	sa[k] = db_seq[si];
	qa[k] = q[qj];
	db_end++;
	i--;
	j--;
	k++;
	btstate = 'S';
	if(tmpscore > cfg.m1_seqT) 
	  perc++;
	else
	  mms++;
	
      } else if( fabs(S[i][j] - F[i][j]) < epsilon ) {
	btstate = 'F';
      } else if( fabs(S[i][j] - D[i][j]) < epsilon ) {
	btstate = 'D';
      } else {
	fprintf(stderr,"This should not happen in S[%d][%d]=%f (Bw motif single 1)\n",i,j,S[i][j]);
	exit(0);
      } 
      break;
    case 'D':
      /* if(q[qj] == '-')  */
      /* if(mS.freq[4][qj] != 0)  */
	/* gap_penalty = 1 - (mS.info[qj]*mS.freq[4][qj]-mS.min[qj]*mS.info[qj])/(mS.max[qj]*mS.info[qj]-mS.min[qj]*mS.info[qj]); */
      /* else */
      	gap_penalty = 1;
      if( fabs(D[i][j] - (S[i][j-1] + cfg.gap_open * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
        j--;	
	k++;
	btstate = 'S';
	gos++;
      }	else if( fabs(D[i][j] - (D[i][j-1] + cfg.gap_extend * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
	j--;
	k++;
	btstate = 'D';
      } else {
	fprintf(stderr,"This should not happen in (Bw motif single 2)\nD[%d][%d]=%f \n",i,j,D[i][j]);
	fprintf(stderr,"S[%d][%d]=%f\n",i,j-1,S[i][j-1]+ cfg.gap_open * gap_penalty);
	fprintf(stderr,"D[%d][%d]=%f\n",i,j-1,D[i][j-1]+ cfg.gap_extend * gap_penalty);
	fprintf(stderr, "gap_penalty=%f sollscore=%f\n", gap_penalty, sollscore);
	exit(0);
      } 
      break;
    case 'F':
      if( fabs(F[i][j] - (S[i-1][j] + cfg.gap_open)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'S';
	gos++;
	gquery++;
      } else if ( fabs(F[i][j] - (F[i-1][j]  + cfg.gap_extend)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'F';
	gquery++;
      } else {
	fprintf(stderr,"This should not happen in F[%d][%d]=%f (Bw motif singel 3)\n",i,j,F[i][j]);
	exit(0);
      }    
      break;
    default:
      fprintf(stderr,"This should not happen at all. btstate: %c\n",btstate);
      exit(0);
    }
    
  }  


  k = strlen(sa);
  
  res[0] = (float) perc / (float) m * 100;
  res[1] = (float) mms;
  res[2] = (float) gos;
  res[3] = (float) k;
  /* res[4] = (float) s_pos - (realend-1) + 1; */
  /* res[5] = (float) si + 1; */
  res[4] = s_pos - perc - mms - gquery + 2; 
  res[5] = s_pos + 1;

  /* fprintf(stderr, "\tbt[4]:%d (perc: %d mms: %d)\t", (int)(res[4]),perc, mms); */
  
  strcpy(ss, sa);
  strcpy(qq, qa);

  for(i=0;i<=len;i++) {
    if(S[i]) free(S[i]);  if(D[i]) free(D[i]); if(F[i]) free(F[i]);
  }
  if(S) free(S); if(D) free(D); if(F) free(F);
  if(qa) free(qa);
  if(sa) free(sa);
  if(q) free(q);

  return res;

}

/* -------------------------------------------------------------------------- */

struct gotoh_motifSingle gotoh_revComplMotifSingle(struct gotoh_motifSingle motif) {

  struct gotoh_motifSingle rm;
  
  return rm;

}

/* END Single motif search */

/* -------------------------------------------------------------------------- */

/* BEGIN 2-sided motif search */

void gotoh_scanDbaseMotif2sided(char *db_seq, int n, char *db_name, gotoh_motif motif,
			  int *score_histoL, int *score_histoR, 
			  float *score_distrL, float *score_distrR, int n_sL, int n_sR, gotoh_settings gs,
			  gotoh_aln List[], int n2add) {

  int i;
  /* struct gotoh_motif rev_motif;  *//* implement later */

  gotoh_fwRecursionMotifL(db_seq, n, motif, db_name, score_histoL, score_distrL, n_sL, gs);

  /* find all plausible right sides for all plausible left sides! */
  for(i=0; i<n; i++) 
    if(score_distrL[i] > (float)(motif.nLeft * gs.match) * gs.m2_seqT) 
      gotoh_fwRecursionMotifR(db_seq, n, motif, db_name, score_histoR, score_distrR, n_sR, gs, i, score_distrL[i]);  
  
}

/* -------------------------------------------------------------------------- */

void gotoh_fwRecursionMotifL(char *db_seq, int n, gotoh_motif motif, char *db_name, int *score_distr,
			     float *score_distrL, int n_s, gotoh_settings cfg) {

  int  i,j, m, transf_score;/* , *score; */
  float p,pp;
  float *S, *S_, *D, *D_, *F, *F_, *tmp;
  float minAS, maxAS, tmpscore, gap_penalty=1;

  m = motif.nLeft;
  
  S   = (float *) calloc(m+1, sizeof(float));
  S_  = (float *) calloc(m+1, sizeof(float));
  D   = (float *) calloc(m+1, sizeof(float));
  D_  = (float *) calloc(m+1, sizeof(float));
  F   = (float *) calloc(m+1, sizeof(float));
  F_  = (float *) calloc(m+1, sizeof(float));

  /* score = (float *) calloc(n+1, sizeof(float)); */
  /* for(i=0; i<=n; i++) { */
  /*   score[i] = -1; */
  /*  /\*  ntf[i] = -1; *\/ */
  /* } */
  
  minAS = abs( 2 * (cfg.gap_open + ((m - 1) * cfg.gap_extend)));
  maxAS = m;
  
  /* initialize semi-local alignment */
  D_[0] = -(cfg.inf);
  F_[0] = -(cfg.inf);
  S_[0] = 0;

  for(j=1;j<=m;j++) { 
    D_[j] = -(cfg.inf);
    F_[j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S_[j] = F[j];
  }

  for(i=1;i<=n;i++) {
    /* init */
    D[0] = 0;  /* local alignment!*/
    F[0] = -cfg.inf;
    S[0] = 0;

    /* align query  against each database position i */
    for(j=1;j<=m;j++) {
      /* if gap the most common character in motif -> decrease gap costs */
      if(motif.maxCL[j-1] == '-') 
	gap_penalty = (motif.infoL[j-1]*motif.stemL[4][j-1]-motif.infoL[j-1]*motif.minL[j-1])/(motif.maxL[j-1]-motif.minL[j-1]);
      else
	gap_penalty = 1;

      /* int p,pp; */
      p  = S[j-1] + cfg.gap_open * gap_penalty;
      pp = D[j-1] + cfg.gap_extend * gap_penalty;
      if(p>pp) D[j] = p;   /* start new insertion */
      else D[j] = pp;      /* extend insertion    */
      
      p = S_[j]  + cfg.gap_open;
      pp = F_[j]  + cfg.gap_extend;
      if(p>pp) F[j] = p;   /* start new deletion */
      else F[j] = pp;      /* extend deletion    */
      
      p = S_[j-1];
      /* if(s[i-1]==q[j-1] && s[i-1] != 'N') p += cfg.match;  /\* match     *\/ */
/*       else p += gotoh_Table[s[i-1]][q[j-1]]; */
      /* /\* else p += cfg.mismatch;  *\/  */           /* mismatch  */
      /* get match/mismatch score from motif matrices */
      tmpscore = gotoh_scoreMotif(db_seq[i-1], motif.stemL, motif.minL, motif.maxL, motif.infoL, j-1);
      /* tmpscore = gotoh_scoreMotifL(db_seq[i-1], motif, j-1); */
      if(tmpscore > cfg.m2_seqT) { /* ==> regarded as match, max is 1 */
	p += tmpscore * cfg.match;
      } else {
	p += tmpscore * cfg.mismatch;
      }
      
      if(D[j]>p) p=D[j];                   /* insertion */
      if(F[j]>p) p=F[j];                   /* deletion  */
      
      S[j] = p;
    }

    /* score_distr2[i] = S[m]; */
    /* if ALN matches with more than 60% add score to distribution arrays */
    if(S[m] > cfg.m2_seqT * (float)(m * cfg.match)) {
      /* printf("db_seq[%d]= %f\n", i, S[m]); */
      score_distrL[i] = S[m];
      /* printf("db_seq[%d]= %f     score_distrL[%d]=%f\n", i, S[m],i,score_distrL[i]); */
      /* transform score - um 0.5 erhoet, damit korrekt gerundet wird*/
      transf_score = (int) (S[m] + minAS + 0.5);
      /* ntf[i] = S[m]; */
      /* score[i] = transf_score; */
      /* nalns++; */
      /* score[i] = S[m]; */
    
      score_distr[transf_score]++; /* sum up to transformed score distribution */
    }
    /* rotate memory */
    tmp = S_; S_ = S; S = tmp;
    tmp = D_; D_ = D; D = tmp;
    tmp = F_; F_ = F; F = tmp;
    
  }

  free(S);free(S_);free(D);free(D_);free(F);free(F_);
  
}

/* -------------------------------------------------------------------------- */

void gotoh_fwRecursionMotifR(char *db_seq, int n, gotoh_motif motif, char *db_name, int *score_distr,
			     float *score_distrR, int n_s, gotoh_settings cfg, int start, float scoreL) {

  int  i,j, m, end, transf_score;/* , *score; */
  float p,pp;
  float *S, *S_, *D, *D_, *F, *F_, *tmp;
  float minAS, maxAS, tmpscore, gap_penalty=1;
  gotoh_motifCandidate mC;
  int backtraced = 0, t;
  int k,l, s, q; /* int of left[i] and right[j] sequences symbol */
  float pairscore;
  
  m = motif.nRight;

  /* define upper limit for distance of boxes */
  
  S   = (float *) calloc(m+1, sizeof(float));
  S_  = (float *) calloc(m+1, sizeof(float));
  D   = (float *) calloc(m+1, sizeof(float));
  D_  = (float *) calloc(m+1, sizeof(float));
  F   = (float *) calloc(m+1, sizeof(float));
  F_  = (float *) calloc(m+1, sizeof(float));

  /* score = (float *) calloc(n+1, sizeof(float)); */
  /* for(i=0; i<=n; i++) { */
  /*   score[i] = -1.; */
  /*  /\*  ntf[i] = -1; *\/ */
  /* } */
  
  minAS = abs( 2 * (cfg.gap_open + ((m - 1) * cfg.gap_extend)));
  maxAS = m;
  
  /* initialize semi-local alignment */
  D_[0] = -(cfg.inf);
  F_[0] = -(cfg.inf);
  S_[0] = 0;

  for(j=1;j<=m;j++) { 
    D_[j] = -(cfg.inf);
    F_[j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S_[j] = F[j];
  }

  end = start + cfg.maxdistance + 1;
  if(end > n) end = n;

  for(i=start;i<end;i++) {
    /* init */
    D[0] = 0;  /* local alignment!*/
    F[0] = -cfg.inf;
    S[0] = 0;

    /* align query  against each database position i */
    for(j=1;j<=m;j++) {
      /* if gap the most common character in motif -> decrease gap costs */
      if(motif.maxCR[j-1] == '-') 
	gap_penalty = (motif.infoR[j-1]*motif.stemR[4][j-1]-motif.infoR[j-1]*motif.minR[j-1])/(motif.infoR[j-1]*motif.maxR[j-1]-motif.infoR[j-1]*motif.minR[j-1]);
      else
	gap_penalty = 1;

     /* int p,pp; */
      p  = S[j-1] + cfg.gap_open * gap_penalty;
      pp = D[j-1] + cfg.gap_extend * gap_penalty;
      if(p>pp) D[j] = p;   /* start new insertion */
      else D[j] = pp;      /* extend insertion    */
      
      p = S_[j]  + cfg.gap_open;
      pp = F_[j]  + cfg.gap_extend;
      if(p>pp) F[j] = p;   /* start new deletion */
      else F[j] = pp;      /* extend deletion    */
      
      p = S_[j-1];
      /* if(s[i-1]==q[j-1] && s[i-1] != 'N') p += cfg.match;  /\* match     *\/ */
/*       else p += gotoh_Table[s[i-1]][q[j-1]]; */
      /* /\* else p += cfg.mismatch;  *\/  */           /* mismatch  */
      /* get match/mismatch score from motif matrices */
      tmpscore = gotoh_scoreMotif(db_seq[i-1], motif.stemR, motif.minR, motif.maxR, motif.infoR, j-1);
      if(tmpscore > cfg.m2_seqT) { /* ==> regarded as match, max is 1 */
	p += tmpscore * cfg.match;
      } else {
	p += tmpscore * cfg.mismatch;
      }
      
      if(D[j]>p) p=D[j];                   /* insertion */
      if(F[j]>p) p=F[j];                   /* deletion  */
      
      S[j] = p;
    }

    /* N++; */ /* count the number of alignments */
    /* score_distr2[i] = S[m]; */
    /* if ALN matches with more than 60% add score to distribution arrays */
    if(S[m] > cfg.m2_seqT * (float)m * (float)cfg.match) {
      /*** BACKTRACE */
      gotoh_bwRecursionMotif(&mC, db_seq, motif, scoreL, start, cfg, 1);
      gotoh_bwRecursionMotif(&mC, db_seq, motif, S[m], i, cfg, 0);
      /* gotoh_printMotifCandidate(mC, db_name, motif); */
      /* check if sequences follow bp pattern of motif */
      /* -> take care of gap positions! */
      /* if(strchr(mC.left_seq, '-')  == NULL && strchr(mC.right_seq, '-')  == NULL) { */
	/* no gaps.. take positions as they are .. */
      pairscore = 0;
      for(k=0; k<motif.nLeft; k++) {
	l=0;
	while(l<motif.nRight) {
	  t = motif.basepairs[k][l];
	  if(t > 0) { /* bases pair -> retrieve score, depending on residues */
	    s = mC.left_seq[k];
	    if(s == '-') { /* gap in db at paired position -> not good! */
	      l++;         
	      pairscore -= 50;      /* add a penalty!  ! */
	      continue;
	    }
	    q = mC.right_seq[l];
	    while(q == '-') { l++; q = mC.right_seq[l]; }
	    switch(s) {
	    case 65:
	      break;
	    case 67:
	      q += 128;
	      break;
	    case 71:
	      q += 256;
	      break;
	    case 85:
	      q += 384;
	      break;
	    default:
	      q += 0;
	    }
	    /* printf("%3d (%3d)  %3d (%3d) %3d    %c-%c -> %f\n",k,k,s, q, t,s,mC.right_seq[l],gotoh_bp[t][q]); */
	    pairscore += gotoh_bp[t][q];

	  }
	  l++;
	}
      }
      mC.scoreBP = pairscore / motif.n_bp;
      mC.scoreBP_perc = mC.scoreBP / motif.scoreBP * 100;
      if(mC.scoreBP_perc > cfg.m2_strucT * 100) {
	mC.score = mC.scoreL + mC.scoreR + mC.scoreBP;
	mC.score_perc = mC.score / motif.maxScore * 100;

	if(mC.score_perc > cfg.m2T * 100) {
	  gotoh_printMotifCandidate(mC, db_name, motif, cfg.output_format);
	  fprintf(stderr, ".");
	}
      }
      /* } else if(strchr(mC.left_seq, '-')  == NULL && strchr(mC.right_seq, '-')  == NULL) { */
      /* 	/\* gaps in database sequence *\/ */
	
      /* } */
      gotoh_freeMotifCandidate(&mC);
      /* if true: insert into sorted list of PAIRS OF CANDIDATES */
      backtraced++; 

      /* fprintf(stderr, "\r# %d candidates backtraced, dbase positon: %d\n", backtraced, i);  */
      /* only if true, insert into score distr etc.. */
      /* printf("db_seq[%d]= %f\n", i, S[m]); */
      score_distrR[i] = S[m];
      /* printf("db_seq[%d]= %f     score_distrR[%d]=%f\n", i, S[m],i,score_distrR[i]); */
      /* transform score - um 0.5 erhoet, damit korrekt gerundet wird*/
      /* transf_score = (int) (S[m] + minAS + 0.5); */
      transf_score = (int) (S[m]  + 0.5 + minAS);
      /* printf("T %d S[m]=%f\n",transf_score,S[m]); */
      /* printf("score: %f tf_score: %d\n",S[m], transf_score); */
      /* exit(0); */
      /* ntf[i] = S[m]; */
      /* score[i] = transf_score; */
      /* nalns++; */
      /* score[i] = S[m]; */

      /* da stehen zu viele drin !!! */
      score_distr[transf_score]++; /* sum up to transformed score distribution */
    }
    /* rotate memory */
    tmp = S_; S_ = S; S = tmp;
    tmp = D_; D_ = D; D = tmp;
    tmp = F_; F_ = F; F = tmp;
    
  }
  /* printf("backtraced: %d\n",backtraced); */

  /* printf("N %d\n",N); */
  free(S);free(S_);free(D);free(D_);free(F);free(F_);/* gotoh_freeMotifCandidate(&mC); */
}

/* -------------------------------------------------------------------------- */
void gotoh_bwRecursionMotif(gotoh_motifCandidate *mC, char *db_seq, gotoh_motif motif,
			    float sollscore, int s_pos, gotoh_settings cfg, int left) {

  int m, i,j,k,len;
  float **m_freq=NULL, *minf=NULL, *maxf=NULL, *infof=NULL;
  float **S, **D, **F, tmpscore, p, pp;
  char *sa, *qa, /* *sx, */ btstate;
  char *q=NULL;
  int si,qj,found, start,gos,mms,perc;
  float *res, epsilon=0.001, istscore, gap_penalty=1;
  char bases2[] = "ACGU";
  int db_end;

  /* fprintf(stderr, "s_pos: %d -> %c\n",s_pos,db_seq[s_pos]); */
  
  m_freq = (float **) calloc(5, sizeof(float*));
  m = motif.nLeft*2 + motif.nRight*2; /* never reached length */
  q = (char *) calloc(m+1, sizeof(char));
  minf = (float *) calloc(m + 1, sizeof(float));
  maxf = (float *) calloc(m + 1, sizeof(float));
  infof = (float *) calloc(m + 1, sizeof(float));
    
  if(left == 1) {
    m = motif.nLeft;

    for(i=0; i<5; i++) {
      m_freq[i] = (float *) calloc(m + 1, sizeof(float));
      for(j=0;j<m;j++) m_freq[i][j] = motif.stemL[i][j];
    }
    
    for(j=0; j<m; j++) {
      strncat(q, bases2+motif.maxCL[j], 1);
      minf[j] = motif.minL[j];
      maxf[j] = motif.maxL[j];
      infof[j] = motif.infoL[j];
    }
    
  }
  else {
    m = motif.nRight;

    for(i=0; i<5; i++) {
      m_freq[i] = (float *) calloc(m + 1, sizeof(float));
      for(j=0;j<m;j++) m_freq[i][j] = motif.stemR[i][j];
    }

    for(j=0; j<m; j++) {
      strncat(q, bases2+motif.maxCR[j], 1);
      minf[j] = motif.minR[j];
      maxf[j] = motif.maxR[j];
      infof[j] = motif.infoR[j];
    }
    
  }

  len = 2 * m + 1;
  if(len > s_pos) len = s_pos;

  S = (float **) calloc(len+2, sizeof(float *));
  D = (float **) calloc(len+2, sizeof(float *));
  F = (float **) calloc(len+2, sizeof(float *));
  for(i=0;i<=len;i++) {
    S[i] = (float *) calloc(m+2, sizeof(float *));
    D[i] = (float *) calloc(m+2, sizeof(float *));
    F[i] = (float *) calloc(m+2, sizeof(float *));
  }
  sa = (char *) calloc(2*m+len+2, sizeof(int *));
  qa = (char *) calloc(2*m+len+2, sizeof(int *));
  
  D[0][0] = (-cfg.inf);
  F[0][0] = (-cfg.inf);
  S[0][0] = 0;

  for(j=1;j<=m;j++) { 
    D[0][j] = (-cfg.inf);
    F[0][j] = (j-1)*cfg.gap_extend + cfg.gap_open;
    S[0][j] = F[0][j];
  }
  
  /* for(i=0; i<4; i++) { */
  /*   for(j=0; j<m; j++) { */
  /*     fprintf(stderr, "%f   ",m_freq[i][j]); */
  /*   } */
  /*   fprintf(stderr,"\n"); */
  /* } */
  /* fprintf(stderr,"m: %d\n",m); */
  
  /* do forward recursion again */
  for(i=1;i<=len;i++) {
    
    si = s_pos-(i-1);
    
    D[i][0] = 0;
    F[i][0] = (-cfg.inf);
    S[i][0] = 0;
    
    for(j=1;j<=m;j++) {
      qj = m-j;

      if(q[qj] == '-') 
	gap_penalty = (infof[qj]*m_freq[4][qj]-infof[qj]*minf[qj])/(infof[qj]*maxf[qj]-infof[qj]*minf[qj]);
      else
	gap_penalty = 1;
       
      p  = S[i][j-1] + cfg.gap_open * gap_penalty;
      pp = D[i][j-1] + cfg.gap_extend * gap_penalty;
      D[i][j] = p > pp ? p : pp;
      
      p  = S[i-1][j] + cfg.gap_open;
      pp = F[i-1][j] + cfg.gap_extend;
      F[i][j] = p > pp ? p : pp;

      p = S[i-1][j-1];

      /* fprintf(stderr, "qj: %d left: %d b: %f\n",qj,left,m_freq[1][qj]); */
      /* fprintf(stderr, "si: %d s: %c len: %d\n",si, db_seq[si],len); */
      tmpscore = gotoh_scoreMotif(db_seq[si], m_freq, minf, maxf, infof, qj);

      if(tmpscore > cfg.m2_seqT) { /* ==> regarded as match, max is 1 */
	p += (tmpscore * cfg.match);
      } else {
	p += (tmpscore * cfg.mismatch);
      }

      if(D[i][j]>p) p=D[i][j];      
      if(F[i][j]>p) p=F[i][j];
      
      S[i][j] = p;
      
    }
			 
  }

  /* printf("\n"); */
  /* for(i=0; i<=len; i++) { */
  /*    for(j=0; j<=m; j++) { */
  /*     printf("  %5.2f ",S[i][j]); */
  /*   } */
  /*    printf("\n"); */
  /* } */
  
  /* find (old) sollscore in S from (new) forward recursion */
  i=0; found = 0;
  while(i<len) {
    if(abs(S[i][m] - sollscore) < 0.5) {
      found = 1;
      break;
    }
    i++;
  }

  istscore = S[i][m];

  /* printf("sollscore: %f %i foundscore: %f found %d\n", sollscore, i, S[i][m], found); */
  /* fflush(stderr); */
  /* exit(0); */
  
  /* i is now the position with our requested score !!! */
  if(found == 0 && cfg.verbose == 1) {
    fprintf(stderr, "WARNING: At position i=%d, there is a better alignment possible\n",s_pos);
    fprintf(stderr, "         than in forward recursion calculated\n");
  }

  start = s_pos-i+1;
  db_end = start;

  res = (float *) calloc(7, sizeof(float));
  /* percId, mm, go, length */
  gos = 0;
  mms = 0;
  perc = 0;
  
  j = m;
  k = 0;
  btstate = 'S';


  while( (j>0) ) {

    if(i<1) break;
    
    si = s_pos -(i-1);
    qj = m -j;

    if(si < 0) {
      while(j>0) {
	sa[k] = '-';
	qa[k] = q[qj]; 
	start++;
	j--;
	k++;
	qj = m -j;
	si = 1;
      }
      break;
    }

    gap_penalty = 1;

    switch(btstate) {
    case 'S':
      p = S[i-1][j-1];
      tmpscore = gotoh_scoreMotif(db_seq[si], m_freq, minf, maxf, infof, qj);
      if(tmpscore > cfg.m2_seqT) p += tmpscore * cfg.match; 
      else p += tmpscore * cfg.mismatch;

      if(fabs(S[i][j] - p) < epsilon) {
      /* if(S[i][j] == S[i-1][j-1] + gotoh_Table[db_seq[si]][q[qj]]) {/\*#*!*\/ */
	sa[k] = db_seq[si];
	qa[k] = q[qj];
	db_end++;
	i--;
	j--;
	k++;
	btstate = 'S';
	
	if(tmpscore > cfg.m2_seqT) 
	  perc++;
	else
	  mms++;
	/* if(gotoh_Table[db_seq[si]][q[qj]] <= gotoh_Table[78][78])/\*#*!*\/ */
	/*   mms++; */
	/* else */
	/*   perc++; */
      }
      else if( fabs(S[i][j] - F[i][j]) < epsilon ) {
	btstate = 'F';
      }
      else if( fabs(S[i][j] - D[i][j]) < epsilon ) {
	btstate = 'D';
      }
      else {
	fprintf(stderr,"This should not happen in S[%d][%d]=%f (Bw motif 2sided 1)\n",i,j,S[i][j]);
	exit(0);
      } 
      break;
    case 'D':
      if(m_freq[4][qj] != 0)
	gap_penalty = (infof[qj]*m_freq[4][qj]-infof[qj]*minf[qj])/(infof[qj]*maxf[qj]-infof[qj]*minf[qj]);
      else
	gap_penalty = 1;
      if(fabs(D[i][j] - (S[i][j-1] + cfg.gap_open * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
        j--;	
	k++;
	btstate = 'S';
	gos++;
      }
      else if(fabs(D[i][j] - (D[i][j-1] + cfg.gap_extend * gap_penalty)) < epsilon ) {
	sa[k] = '-';
	qa[k] = q[qj];
	start++;
	j--;
	k++;
	btstate = 'D';
      }
      else {
	fprintf(stderr,"This should not happen in D[%d][%d]=%f (Bw motif 2sided 2)\n",i,j,D[i][j]);
	exit(0);
      } 
      break;
    case 'F':
      if(fabs(F[i][j] - (S[i-1][j] + cfg.gap_open)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'S';
	gos++;
      }
      else if (fabs(F[i][j] - (F[i-1][j]  + cfg.gap_extend)) < epsilon ) {
	sa[k] = db_seq[si];
	qa[k] = '-';
	db_end++;
	i--;
	k++;
	btstate = 'F';
      }
      else {
	fprintf(stderr,"This should not happen in F[%d][%d]=%f (Bw motif 2sided 3)\n",i,j,F[i][j]);
	exit(0);
      }    
      break;
    default:
      fprintf(stderr,"This should not happen at all. btstate: %c\n",btstate);
      exit(0);
    }
    
  }  

  k = strlen(sa);


  if(left == 1) {
    mC->left_seq = (char *) calloc(strlen(sa)+1, sizeof(char));
    strcpy(mC->left_seq, sa);
    mC->left_mseq = (char *) calloc(strlen(qa)+1, sizeof(char));
    strcpy(mC->left_mseq, qa);
    mC->scoreL = istscore;
    mC->scoreL_perc = mC->scoreL / (motif.nLeft*cfg.match) * 100;
    mC->sL = start+1;
    mC->eL = db_end;
  } else {
    mC->right_seq = (char *) calloc(strlen(sa)+1, sizeof(char));
    strcpy(mC->right_seq, sa);
    mC->right_mseq = (char *) calloc(strlen(qa)+1, sizeof(char));
    strcpy(mC->right_mseq, qa);
    mC->scoreR = istscore;
    mC->scoreR_perc = mC->scoreR / (motif.nRight*cfg.match) * 100;
    mC->sR = start+1;
    mC->eR = db_end;
    mC->distance = mC->sR - mC->eL + 1;
    mC->score = mC->scoreL + mC->scoreR;
    mC->score_perc = mC->score / ((motif.nLeft + motif.nRight)*cfg.match) * 100;

    if(mC->sL == 236) {
        printf("%s\n%s\n",qa,sa);
    }
  }
  
  res[0] = (float) perc / (float) m * 100;
  res[1] = (float) mms;
  res[2] = (float) gos;
  res[3] = (float) k;
  res[4] = (float) start + 1;
  res[5] = (float) db_end;
  if(res) free(res);
  
  for(i=0; i<5; i++) if(m_freq[i] != NULL) free(m_freq[i]);
  if(m_freq != NULL) free(m_freq);
  if(q) free(q);
  if(minf) free(minf); if(maxf) free(maxf); if(infof) free(infof);
  for(i=0;i<=len;i++) {
    if(S[i]) free(S[i]);  if(D[i]) free(D[i]); if(F[i]) free(F[i]);
  }
  if(S) free(S); if(D) free(D); if(F) free(F);
  if(qa) free(qa);
  if(sa) free(sa);

  return;

}

/* -------------------------------------------------------------------------- */

struct gotoh_motifCandidate gotoh_backtraceMotif(char *db_seq, gotoh_motif motif, float maxL, int maxL_i,
			  float maxR, int maxR_i, gotoh_settings cfg) {

  gotoh_motifCandidate mC;
  
  /* gotoh_initMotifCandidate(mC, motif); */

  /* backtrace left side */
  gotoh_bwRecursionMotif(&mC, db_seq, motif, maxL, maxL_i, cfg, 1);

  /* backtrace right side */
  gotoh_bwRecursionMotif(&mC, db_seq, motif, maxR, maxR_i, cfg, 0);

  return mC;

}

/* -------------------------------------------------------------------------- */

void gotoh_initMotifCandidate(gotoh_motifCandidate *mC, gotoh_motif m) {

  mC->left_seq = (char *) calloc(2*m.nLeft + 1, sizeof(char));
  mC->right_seq = (char *) calloc(2*m.nRight + 1, sizeof(char));
 
  return;
  
}

/* -------------------------------------------------------------------------- */

void gotoh_freeMotifCandidate(gotoh_motifCandidate *m) {

  if(m->left_seq) free(m->left_seq);
  if(m->right_seq) free(m->right_seq);
  if(m->left_mseq) free(m->left_mseq);
  if(m->right_mseq) free(m->right_mseq);
  
  return;
  
}

/* -------------------------------------------------------------------------- */

/* void gotoh_freeMotif(gotoh_motif m) { */

/*   int i; */
  
/*   free(m.comment); */
/*   free(m.name); */
  
/*   for(i=0; i<5; i++) { */
/*     free(m.stemL[i]); free(m.stemR[i]); */
/*   } */
/*   free(m.stemL); free(m.stemR); */

/*   free(m.minL); free(m.maxL); free(m.infoL); */
/*   free(m.minR); free(m.maxR); free(m.infoR); */
  
/*   free(m.maxCL); free(m.maxCR); */

/*   free(m.consL); free(m.consR); */

/*   free(m.basepairs[0]); free(m.basepairs[1]); free(m.basepairs[2]); */
/*   free(m.basepairs); */

  

/* } */

/* END 2-sided motif search */
/* -------------------------------------------------------------------------- */

/* End of file */
