/* motifCALC.h */

#ifndef mCALC_H
#define mCALC_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "read.h"
#include "structs.h"
#include "calc.h"

#define MAX_ALNS 1000   /* max. number of alignments per query sequence */

void gotoh_initBasePairTable();

/* -------------------------------------------------------------------------- */
/* BEGIN Single motif search */
/* fastaALN2frequency.pl -i mir-92_deut.aln.fa > mir-92_deut.aln.fa.pattern */

/* void gotoh_fwRecursionMotifSingle(struct farray * scores, char *db_seq, int n, gotoh_motifSingle motif, */
/* 				  char *db_name, int *score_histo, int n_s, gotoh_settings cfg, int n2add, char strand); */
void gotoh_fwRecursionMotifSingle(char *db_seq, int n, struct gotoh_motifSingle motif,
				  struct farray *scores, int *score_histo,
				  struct gotoh_settings cfg, char strand) ;

float gotoh_getLocalMaxMotif(struct farray *scores, struct gotoh_motifSingle mS,
			     struct gotoh_aln List[], struct gotoh_settings gs,
			     char *db_seq, char *db_name, char strand, struct iarray *lm);

void gotoh_findLocalMaximaMotifSingle(struct farray *scores, gotoh_aln List[], int s, int e,
				      char *db_seq, char *db_name, gotoh_motifSingle mS,
				      char strand, struct gotoh_settings gs, struct iarray *lm, int db_len);

float * gotoh_bwRecursionMotifSingle2(char *db_seq, gotoh_motifSingle mS, int s_pos, gotoh_settings cfg,
				      char *ss, char *qq, float sollscore, int n2add,
				      int sA, int eA);

/* void gotoh_findLocalMaximaMotifSingle(struct farray * scores, gotoh_aln List[], int n2add, int s, int e, */
/* 				      char *db_seq, char *db_name, gotoh_motifSingle mS, char strand, */
/* 				      gotoh_settings gs, int Len, int *score_histo, int n_s, struct iarray * lm); */

void gotoh_getMaxLinearF(struct farray *scores, int s, int e, float *maxS, int *maxI);

int gotoh_backtraceAlnMotifSingle(int ii, int maxI, float maxS, char strand, char *db_name,
				   char *db_seq, gotoh_motifSingle mS, gotoh_aln List[],
				   int n2add, gotoh_settings gs, struct farray *scores);

float * gotoh_bwRecursionMotifSingle(char *db_seq, gotoh_motifSingle mS, int s_pos, gotoh_settings cfg,
				     char *ss, char *qq, float sollscore, int n2add);

struct gotoh_motifSingle gotoh_revComplMotifSingle(struct gotoh_motifSingle motif);

/* END Single motif search */

/* -------------------------------------------------------------------------- */

/* BEGIN 2-sided motif search */

void gotoh_scanDbaseMotif2sided(char *db_seq, int n, char *db_name, gotoh_motif motif,
				int *score_histoL, int *score_histoR, 
				float *score_distrL, float *score_distrR, int n_sL, int n_sR, gotoh_settings gs,
				gotoh_aln List[], int n2add);

void gotoh_fwRecursionMotifL(char *db_seq, int n, gotoh_motif motif, char *db_name, int *score_distr,
			     float *score_distrL, int n_s, gotoh_settings cfg);

void gotoh_fwRecursionMotifR(char *db_seq, int n, gotoh_motif motif, char *db_name, int *score_distr,
			     float *score_distrR, int n_s, gotoh_settings cfg, int start, float scoreL);

void gotoh_bwRecursionMotif(gotoh_motifCandidate *mC, char *db_seq, gotoh_motif motif,
			    float sollscore, int s_pos, gotoh_settings cfg, int left);

struct gotoh_motifCandidate gotoh_backtraceMotif(char *db_seq, gotoh_motif motif, float maxL, int maxL_i,
			  float maxR, int maxR_i, gotoh_settings cfg);

void gotoh_initMotifCandidate(gotoh_motifCandidate *mC, gotoh_motif m);

void gotoh_freeMotifCandidate(gotoh_motifCandidate *m);

/* void gotoh_freeMotif(gotoh_motif m); */

/* END 2-sided motif search */
/* -------------------------------------------------------------------------- */

#endif

/* End of file */
