/* singleSequenceCALC.h */

#ifndef ssCALC_H
#define ssCALC_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "read.h"
#include "structs.h"
#include "calc.h"

#define MAX_ALNS 1000   /* max. number of alignments per query sequence */

void gotoh_initMatchTable(gotoh_settings gs);

/* -------------------------------------------------------------------------- */

void gotoh_fwRecursion(char *s, int n, char *q, int m, struct iarray *scores, int *score_distr,
		       struct gotoh_settings cfg, char strand);

/* s and q are the input sequences, s_pos start position of alignment, cfg settings
   ss and qq are the backtracked aligned result sequences */
/* returns length of alignment */
float * gotoh_bwRecursion(char * s,char * q, int m, int s_pos, gotoh_settings cfg,
			  char *ss, char *qq, int sollscore, int n2add);

float * gotoh_bwRecursion2(char * s,char * q, int m, int s_pos, gotoh_settings cfg,
			   char *ss, char *qq, int sollscore, int n2add, int sA, int eA);

void gotoh_findLocalMaxima(struct iarray *scores, gotoh_aln List[], int s, int e,
			   char *db_seq, char *db_name, char *q_seq, char *q_name, int m,
			   char strand, struct gotoh_settings gs, struct iarray *lm, int db_len);

void gotoh_getMaxLinear(struct iarray *scores, int s, int e, int *ms, int *mi);

int gotoh_backtraceAln2(int ii, int imax, int smax, char strand, char *s_name, char* q_name,
			 gotoh_aln List[], int m, char *db_seq, char *q_seq,
			 gotoh_settings gs, int n2add, struct iarray *scores);

char * goto_revCompl(char *sequence, int v, int len);

/* -------------------------------------------------------------------------- */

#endif
/* End of file */
