# stats.R

# how are the scores expected to be distributed
go = -8
ge = -2
m = 3
mm = -1

n = 100

z = read.table('infiles/dme-3R_mir-92a.GS2.localMaxima.dat')
z = read.table('t'); # non-log scores of local maxima over database

idx = (z[, 3] != 0)
score = z[idx, 2]
score
counts = log(z[idx ,3])
counts

l = length(score)
l

##################### the good old function fittings ###########################

source("/homes/brauerei/jana/CURRENT/PROJECTS/gotoh/stats/jana/functions/trunc-ml.R")
source("/homes/brauerei/jana/CURRENT/PROJECTS/gotoh/stats/jana/functions/m1-normal.R")
source("/homes/brauerei/jana/CURRENT/PROJECTS/gotoh/stats/jana/functions/m2-lognormal.R")
source("/homes/brauerei/jana/CURRENT/PROJECTS/gotoh/stats/jana/functions/m3-gamma.R")
source("/homes/brauerei/jana/CURRENT/PROJECTS/gotoh/stats/jana/functions/m4-gumbel.R")

z = read.table('aae.6S.GS2.lmh')
idx = (z[, 3] > 0)
score = z[idx, 2]
score
counts = log(z[idx ,3])
counts

l = length(score)
l

sc = sum(counts)
sc # 52830954
r = range(score) # -214  233
r
new.n = 50000
newcounts = round(counts/sc*new.n)
z =  rep(score, newcounts)
length(z)


hist(z, bre="FD", freq=FALSE, xlim=r)
min.z=1305
max.z=1325
outside.mass.emp = (sum(counts[score < min.z]) + 
                   sum(counts[score > max.z]) ) /sc
outside.mass.emp

get.eta0 = function(model, param)
{
  outside.mass.th = 1 - (model$F0(max.z, param)-model$F0(min.z, param))
  eta0 = max(1, outside.mass.th/outside.mass.emp)
  return(eta0)
}

# for plotting
zzz = seq( min(z), max(z), length.out=500) 
xxx = seq( min(score), max(score), length.out=1000) 
xxt = seq( min.z, max.z, length.out=1000) 
BRE="fd"
BRE="Sturges"
BRE=50

#pdf(file="Aquifex_aeolicus-RF00013-Fit.pdf", width=12)

par(mfcol=c(2,4))


## m1: normal

o1 = truncated.ml (z, min.z, max.z, m1)
h = hist(z, bre=BRE, freq=FALSE, main="normal")
lines(zzz, m1$f0(zzz, o1), col=2)
lines(c(min.z, min.z), c(0, max(h$density)), col=4, lwd=2)
lines(c(max.z, max.z), c(0, max(h$density)), col=4, lwd=2)

plot(score, counts/sc, type="l", log="y", main="normal")
eta0 = get.eta0(m1, o1)
lines(xxx, eta0*m1$f0(xxx, o1), col=3)
lines(xxt, eta0*m1$f0(xxt, o1), col=4, lwd=2)


## m2: log-normal

o2 = truncated.ml (z, min.z, max.z, m2)
h = hist(z, bre=BRE, freq=FALSE, main="log-normal")
lines(zzz, m2$f0(zzz, o2), col=2)
lines(c(min.z, min.z), c(0, max(h$density)), col=4, lwd=2)
lines(c(max.z, max.z), c(0, max(h$density)), col=4, lwd=2)

plot(score, counts/sc, type="l", log="y", main="log-normal")
eta0 = get.eta0(m2, o2)
lines(xxx, eta0*m2$f0(xxx, o2), col=3)
lines(xxt, eta0*m2$f0(xxt, o2), col=4, lwd=2)


## m3: gamma

o3 = truncated.ml (z, min.z, max.z, m3)
h = hist(z, bre=BRE, freq=FALSE, main="gamma")
lines(zzz, m3$f0(zzz, o3), col=2)
lines(c(min.z, min.z), c(0, max(h$density)), col=4, lwd=2)
lines(c(max.z, max.z), c(0, max(h$density)), col=4, lwd=2)

plot(score, counts/sc, type="l", log="y", main="gamma")
eta0 = get.eta0(m3, o3)
lines(xxx, eta0*m3$f0(xxx, o3), col=3)
lines(xxt, eta0*m3$f0(xxt, o3), col=4, lwd=2)


## m4: gumbel

o4 = truncated.ml (z, min.z, max.z, m4)
h = hist(z, bre=BRE, freq=FALSE, main="gumbel")
lines(zzz, m4$f0(zzz, o4), col=2)
lines(c(min.z, min.z), c(0, max(h$density)), col=4, lwd=2)
lines(c(max.z, max.z), c(0, max(h$density)), col=4, lwd=2)

plot(score, counts/sc, type="l", log="y", main="gumbel")
eta0 = get.eta0(m4, o4)
lines(xxx, eta0*m4$f0(xxx, o4), col=3)
lines(xxt, eta0*m4$f0(xxt, o4), col=4, lwd=2)

#dev.off()

################################################################################

plot(score, counts, xlim=range(score), ylim=c(-20, 10), main="Fitted tail of distribution", xlab="score", ylab="log(#alns)", pch=15, cex=0.5)

maxCounts = max(counts)
maxtmp = score[which(counts == maxCounts)]
maxCountsScore = maxtmp[length(maxtmp)]
maxCounts
maxCountsScore

maxI = which(score == maxCountsScore)
maxI

# data right of maximum
rscore = score[maxI:l]
rcounts = counts[maxI:l]

# get half counts positon
halfCounts = 0.5*maxCounts
halfCounts
tmp = which(rcounts > halfCounts)
i = tmp[length(tmp)]
halfCountsScore = rscore[i]
halfCountsScore
halfCounts = rcounts[i]
halfCounts

# get range for linear regression
range = 0.125 * maxCounts
range
tmp = halfCounts - range
tmp2 = which(rcounts > tmp)
ri = tmp2[length(tmp2)]
tmp = halfCounts + range
tmp2 = which(rcounts > tmp)
li = tmp2[length(tmp2)]
li
ri

####
# solve linear systems of equations to get tangente and cut point
lm.x = rscore[li:ri]
lm.y = rcounts[li:ri]
lm.x
lm.y

lines(lm.x, lm.y, type="p", cex=1, pch=4, col=3)

A = sum(lm.x)
B = sum(lm.y)
C = sum(lm.x*lm.x)
D = sum(lm.x*lm.y)
N = length(lm.x)

A
B
C
D
N

m = (N*D - A*B) / (N*C - A*A)
n = (D - m*C) / A

m
n


tan = function(x, m, n) { m*x + n }

lines(rscore, tan(rscore, m, n), type="l", col=3, lty=2)

# the cut point with y=0(log!)=const.
tmp = (-n)/m
ttmp = which(rscore <= tmp)
cutr = ttmp[length(ttmp)]
cutr

lines(rscore[cutr], rcounts[cutr], type="p", pch=1, cex=1, lw=2, col=4)

# get left side of fit range
s0 = (round(halfCountsScore - 0.5 * (halfCountsScore - maxCountsScore)))
tmp = which(rscore >= s0)
cutl = tmp[1]
cutl

lines(rscore[cutl], rcounts[cutl], type="p", pch=1, cex=2, lw=2, col=4)

####
# solve linear systems of equations to fit a curve to the data
#xvals = read.table('xvals')$V3
#yvals = read.table('yvals')$V3
xvals = rscore[cutl:cutr]
yvals = rcounts[cutl:cutr]

A = sum(xvals)
B = sum(log(xvals))
C = sum(xvals*log(xvals))
D = sum(xvals*xvals)
E = sum(log(xvals)*log(xvals))
F = sum(xvals*yvals)
G = sum(yvals*log(xvals))
H = sum(yvals)
N = length(xvals)

a2 = ((A*H-N*F)*(A*B-N*C) - (B*H-N*G)*(A*A-N*D)) / ((A*B-N*C)^2 - (A*A-N*D)*(B*B-N*E))
a1 = (A*H - N*F - (A*B-N*C)*a2) / (A*A-N*D)
a0 = (H - B*a2 - A*a1) / N

a0
a1
a2

Phi = function(x, a0, a1, a2) {
  a0 + a1*x + a2*log(x);
}

lines(rscore, Phi(rscore, a0, a1, a2), type="l", col=5);

Fit = function(x, a0, a1, a2, A, D, F, H, S, m, n) {
  if(a1>0) {
    m = (S*F - A*H) / (S*C - A*A);
    N = (F - m*D) / A;
    k = 1/exp(tan(cutr,m,N));
    tan(x, m, N);  
  } else {
    k = 1/exp(Phi(cutr, a0, a1, a2));
    Phi(x);
  }
}

#yvalsf = Phi(xvals, a0, a1, a2)
#countsf = Phi(score, a0, a1, a2)
fit = Fit(rscore, a0, a1, a2, A, D, F, H, N)
lines(rscore, tan(rscore, m, N), type="l", col=3, lty=2)

lines(rscore, exp(fit), col=5)


#lines(xvals, yvals, col=2, type="p", pch=16, cex=1)
#lines(xvals, yvalsf, col=3)
lines(score, countsf, col=4)
# End of file

l         # number of datapoints
cutl      # left fit border
cutr      # right fit border
cutr-cutl # number of datapoints in fitrange

###### plot fitregion only #####################################################

dev.off()

pdf(file="Dme3R_mir-92a_FitRegion.pdf", width=12)

plot(rscore, rcounts, type="p", cex=0.8, pch=16, xlim=c(380,450))
lines(lm.x, lm.y, type="p", cex=1.2, pch=1, col=3,lw=2)
lines(rscore, tan(rscore, m, n), type="l", col=3, lty=2, lw=2)
lines(rscore[cutr], rcounts[cutr], type="p", pch=1, cex=1, lw=2, col=2)
lines(rscore[cutl], rcounts[cutl], type="p", pch=1, cex=2, lw=2, col=2)
lines(rscore, Phi(rscore, a0, a1, a2), type="l", col=2);

dev.off()

###### plot whole region with fit ##############################################

dev.off()

pdf(file="Dme3R_mir-92a_CompleteRegion.pdf", width=12)

plot(rscore, rcounts, type="p", cex=0.8, pch=16, ylim=c(range(Phi(rscore, a0, a1, a2))))
lines(lm.x, lm.y, type="p", cex=1.2, pch=1, col=3,lw=2)
lines(rscore, tan(rscore, m, n), type="l", col=3, lty=2, lw=2)
lines(rscore[cutr], rcounts[cutr], type="p", pch=1, cex=1, lw=2, col=2)
lines(rscore[cutl], rcounts[cutl], type="p", pch=1, cex=2, lw=2, col=2)
lines(rscore, Phi(rscore, a0, a1, a2), type="l", col=2);

dev.off()

###### add motif stuff #########################################################

plot(md.x, md.y, type="p", cex=1, pch=1, col=3, xlim=c(min(rscore), max(md.x)))
lines(rscore, rcounts, type="p", cex=0.8, pch=16)



################################################################################

